<template>
  <div>
    <!--<template>
      <hsc-window-style-white>
        <hsc-window
          style=" z-index:2000"
          :resizable="true"
          :isScrollable="true"
          :minHeight="300"
          :maxHeight="500"
          :minWidth="300"
          :maxWidth="400"
          title="Viewer Objects"
          :width="400"
          :height="700"
        >
          <json-view :data="$v" />
        </hsc-window>
      </hsc-window-style-white>
    </template>-->
    <div class="titulo">
      <div class="ruta">
        <v-breadcrumbs :items="breadcrumbs">
          <template v-slot:divider>
            <v-icon>mdi-chevron-right</v-icon>
          </template>
        </v-breadcrumbs>
      </div>
      <strong>{{ textoGestionFranquicia }}</strong>
    </div>
    <!--Contenido-->
    <div class="pl-10 pr-10 contSecc">
      <div class="titSec">
        {{ textoGestionFranquicia }}
      </div>
      <div class="CampoOblogario">
        Campo requerido
        <span class="tRojo">*</span>
      </div>
      <div class="gris">
        <v-row>
          <v-col :cols="12" :sm="12" :md="5" :lg="5" :xl="4">
            Nombre de la Franquicia
            <span class="tRojo">*</span>
            <br />
            <v-text-field
              v-model.trim="franquicia.descripcion"
              outlined
              solo
              maxlength="50"
              flat
              dense
              :error="$v.franquiciaVuelidate.descripcion.error"
              hint-align="right"
              :hint="
                'CARACTERES RESTANTES ' +
                  serviceCommons.remaningCharacters(franquicia.descripcion, 50)
              "
              background-color="white"
            >
              <template
                v-if="
                  $v.franquiciaVuelidate.descripcion.$error ||
                    !isUniqueFranquicia
                "
                v-slot:append
              >
                <v-popover placement="bottom-end" color="red" offset="16">
                  <v-icon class color="#fd5151">mdi-alert-circle</v-icon>
                  <template slot="popover">
                    <div
                      @click="$v.franquiciaVuelidate.descripcion.$reset"
                      v-close-popover
                    >
                      <div v-if="!$v.franquiciaVuelidate.descripcion.required">
                        ¡No te olvides de éste campo!
                      </div>
                      <div
                        @click="isUniqueFranquicia = !isUniqueFranquicia"
                        v-if="
                          !isUniqueFranquicia &&
                            $v.franquiciaVuelidate.descripcion.required
                        "
                      >
                        ¡Encontramos su gemela! nombre del negocio duplicado
                      </div>
                    </div>
                  </template>
                </v-popover>
              </template>
            </v-text-field>
          </v-col>
        </v-row>
      </div>
      <div>
        <div>
          Selecciona los negocios asociados a la franquicia y las categorías
          asociadas al negocio. Para nuevos negocios
          <v-btn
            style="margin-top:-3px;"
            x-small
            color="primary"
            :to="cardNegocios.to"
            >click aquí</v-btn
          >
          <div
            v-if="$v.franquiciaVuelidate.negocios_franquicia.$error"
            class="float-right"
          >
            <v-popover placement="bottom-end" offset="16">
              <v-icon class color="#fd5151">mdi-alert-circle</v-icon>
              <template slot="popover">
                <div
                  @click="$v.franquiciaVuelidate.negocios_franquicia.$reset"
                  v-close-popover
                >
                  <div
                    v-if="!$v.franquiciaVuelidate.negocios_franquicia.required"
                  >
                    ¡Mínimo es un negocio!
                  </div>
                  <div
                    v-if="
                      $v.franquiciaVuelidate.negocios_franquicia.$error &&
                        $v.franquiciaVuelidate.negocios_franquicia.required
                    "
                  >
                    ¡Es necesario validar todos los negocios!
                  </div>
                </div>
              </template>
            </v-popover>
          </div>
        </div>
        <div class="mt-8">
          <v-sheet class="overflow-y-auto CardScroll">
            <v-row>
              <v-col
                v-for="(itemNegocio, indexItemNegocio) in negocios"
                :key="indexItemNegocio"
                :xs="12"
                :sm="12"
                :md="6"
                :lg="3"
                v-show="itemNegocio.descripcion !== 'GEK'"
              >
                <v-card class="generalCard pa-0 ma-0">
                  <div>
                    <v-checkbox
                      v-model="itemNegocio.is_checked"
                      @change="switchCheckNegocioFranquicia"
                      color="primary"
                      class="float-right ma-2 pa-0"
                      x-small
                    ></v-checkbox>
                  </div>
                  <img
                    :src="itemNegocio.path_logo"
                    :width="250"
                    height="150"
                    class="pa-0 ma-0"
                    style
                  />
                  <v-card-text class="justify-center">
                    <div class>{{ itemNegocio.descripcion }}</div>
                  </v-card-text>
                  <v-autocomplete
                    class="categorias"
                    v-if="itemNegocio.is_checked"
                    v-model="itemNegocio.ids_categorias"
                    @change="switchCheckNegocioFranquicia"
                    :items="itemNegocio.categorias"
                    item-value="id_categoria"
                    item-text="descripcion"
                    no-data-text="Agrega categorías desde el módulo de NEGOCIOS"
                    chips
                    small-chips
                    multiple
                    solo
                    label="CATEGORÍAS"
                    :error="
                      $v.franquiciaVuelidate.negocios_franquicia.$each[
                        getIndexNegocioFranquiciaById(itemNegocio.id_negocio)
                      ].ids_categorias.$error
                    "
                  >
                    <template v-slot:selection="{ item, index }">
                      <v-chip label small v-if="index < 3">
                        <span>{{ item.descripcion }}</span>
                      </v-chip>
                      <span v-if="index === 3" class="grey--text caption">
                        (+{{
                          franquicia.negocios_franquicia[
                            getIndexNegocioFranquiciaById(
                              itemNegocio.id_negocio
                            )
                          ].ids_categorias.length - 3
                        }}
                        otros)
                      </span>
                    </template>
                    <template
                      v-if="
                        getIndexNegocioFranquiciaById(itemNegocio.id_negocio) &&
                          $v.franquiciaVuelidate.negocios_franquicia.$each[
                            getIndexNegocioFranquiciaById(
                              itemNegocio.id_negocio
                            )
                          ].ids_categorias.$error
                      "
                      v-slot:append-outer
                    >
                      <v-popover placement="bottom-end" offset="16">
                        <v-icon class color="#fd5151">mdi-alert-circle</v-icon>
                        <template slot="popover">
                          <span
                            @click="
                              $v.franquiciaVuelidate.negocios_franquicia.$each[
                                getIndexNegocioFranquiciaById(
                                  itemNegocio.id_negocio
                                )
                              ].ids_categorias.$reset()
                            "
                            v-close-popover
                          >
                            <span
                              v-if="
                                !$v.franquiciaVuelidate.negocios_franquicia
                                  .$each[
                                  getIndexNegocioFranquiciaById(
                                    itemNegocio.id_negocio
                                  )
                                ].ids_categorias.required
                              "
                              >¡No te olvides de éste campo!</span
                            >
                          </span>
                        </template>
                      </v-popover>
                    </template>
                  </v-autocomplete>
                </v-card>
              </v-col>
            </v-row>
          </v-sheet>
        </div>
      </div>
      <div class="btnCenter">
        <v-btn
          class="mr-6"
          depressed
          dark
          tile
          color="secundary"
          @click="dialogCancel = true"
          :class="[{ desac: !hasGlobalChanges }]"
          >Cancelar cambios</v-btn
        >
        <v-btn
          depressed
          dark
          tile
          color="primary"
          @click.stop="guardarCambios"
          :class="[
            { desac: !hasGlobalChanges },
            { desac: savingFranquicia },
            { 'error-validation-btn': $v.$invalid }
          ]"
          >Guardar cambios</v-btn
        >
      </div>
    </div>
    <!-- Dialogs-->
    <template>
      <v-dialog
        v-model="dialogErrorValidationNombreFranquicia"
        persistent
        max-width="600px"
      >
        <v-card>
          <v-card-title>
            <div class="titModal titModaleError">
              <strong>¡Oh oh!</strong>
              Ocurrio un error al validar el nombre de la franquicia
            </div>
          </v-card-title>
          <v-card-text
            >¡No hay de que preocuparse! Solo tienes que
            corregirlos.</v-card-text
          >
          <v-card-actions>
            <v-row justify="center" style="margin-right:0px">
              <v-btn
                class="ma-2"
                dark
                tile
                depressed
                color="error"
                @click="dialogErrorValidationNombreFranquicia = false"
                >¡De acuerdo!</v-btn
              >
            </v-row>
          </v-card-actions>
        </v-card>
      </v-dialog>
      <v-dialog v-model="dialogErrorValidation" persistent max-width="600px">
        <v-card>
          <v-card-title>
            <div class="titModal titModaleError">
              <strong>¡Oh oh!</strong>
              Tienes algunos conflictos de validación
            </div>
          </v-card-title>
          <v-card-text
            >¡No hay de que preocuparse! Solo tienes que
            corregirlos.</v-card-text
          >
          <v-card-actions>
            <v-row justify="center" style="margin-right:0px">
              <v-btn
                class="ma-2"
                dark
                tile
                depressed
                color="error"
                @click="dialogErrorValidation = false"
                >Aceptar</v-btn
              >
            </v-row>
          </v-card-actions>
        </v-card>
      </v-dialog>
      <v-dialog v-model="dialogCancel" persistent max-width="600px">
        <v-card>
          <v-card-title>
            <div class="titModal">
              ¿Seguro que deseas
              <strong>cancelar</strong> los cambios realizados?
            </div>
          </v-card-title>
          <v-card-text></v-card-text>
          <v-card-actions>
            <v-row justify="center" style="margin-right:0px">
              <v-btn
                class="ma-2"
                dark
                tile
                depressed
                color="secondary"
                @click="dialogCancel = false"
                >No, cancelar</v-btn
              >
              <v-btn
                class="ma-2"
                depressed
                dark
                tile
                color="primary"
                @click="cancelGlobalChanges()"
                >Si, continuar</v-btn
              >
            </v-row>
          </v-card-actions>
        </v-card>
      </v-dialog>
      <v-dialog v-model="dialogSave" persistent max-width="600px">
        <v-card>
          <v-card-title>
            <div class="titModal">
              ¡Se han
              <strong>guardado los cambios de manera exitosa!</strong>
            </div>
          </v-card-title>
          <v-card-text></v-card-text>
          <v-card-actions>
            <v-row justify="center" style="margin-right:0px">
              <v-btn
                :to="cardFranquicia.to"
                class="ma-2"
                depressed
                dark
                tile
                color="primary"
                @click="dialogSave = false"
                >Regresar a Franquicias</v-btn
              >
            </v-row>
          </v-card-actions>
        </v-card>
      </v-dialog>
    </template>
    <LeavePage ref="LeavePage" />
  </div>
</template>
<style scoped>
.categorias {
  height: 48px;
}
.rowInactive .tooltiptext3 .tooltiptext4 {
  visibility: hidden !important;
}
.ponderacion .fixed.tooltiptext3 .fixed.tooltiptext4 {
  bottom: -15px;
  left: -40px;
}
.ponderacion .tooltiptext3 .tooltiptext4 {
  bottom: -40px;
  left: -60px;
}
.titSec .tooltiptext3 .tooltiptext4 {
  bottom: -30px;
  left: -40px;
}
.tooltiptext3 {
  background-color: #fd5151 !important;
  color: #fff;
  text-align: center;
  padding: 5px 12px;
  white-space: nowrap;
  position: relative;
  z-index: 1;
  z-index: 1;
  bottom: 0;
  left: -15px;
  font-weight: 100;
  font-size: 1em;
  transform: scale(0.75);
}
.tooltiptext4 {
  background-color: #fd5151 !important;
  color: #fff;
  text-align: center;
  padding: 5px 12px;
  white-space: nowrap;
  position: absolute;
  z-index: 1;
  z-index: 1;
  bottom: -30px;
  left: -29px;
  font-weight: 100;
  font-size: 1em;
  transform: scale(0.75);
}
.tooltiptext3:after,
.tooltiptext4:after {
  width: 0;
  height: 0;
  border-style: solid;
  /* border-width: 20px 20px 20px 20px; */
  border-left: 15px solid transparent;
  border-right: 15px solid transparent;
  border-bottom: 15px solid #fd5151;
  border-top: 0px;
  /* border-color: #67ef00 transparent transparent transparent; */
}
.tooltiptext3:after,
.tooltiptext3:before,
.tooltiptext4:after,
.tooltiptext4:before {
  left: 10px;
  top: -45%;
  content: "";
  height: 0;
  width: 0;
  position: absolute;
  pointer-events: none;
}
</style>
<script>
import axios from "axios";
import Vuex from "vuex";
import { mapState } from "vuex";
import store from "@/store";
import { required } from "vuelidate/lib/validators";
import { setTimeout } from "timers";
import { log } from "util";
import LeavePage from "@/views/secure/commons/LeavePage.vue";
const serviceCommons = store.state.serviceCommons;
const serviceLocalStorage = store.state.serviceLocalStorage;
const user = serviceLocalStorage.userToken();
const urlServicesPlataformaFranquicia =
  store.state.urlServicesPlataformaFranquicia;
export default {
  name: "Component-GestionarNegocios",
  components: {
    LeavePage
  },
  data() {
    return {
      savingFranquicia: false,
      dialogCancel: false,
      dialogSave: false,
      dialogErrorValidationNombreFranquicia: false,
      dialogErrorValidation: false,
      isUniqueFranquicia: true,
      cardFranquicia: {
        to: {
          name: "modelo_franquicia_franquicias"
        }
      },
      cardNegocios: {
        title: "NEGOCIOS",
        src: require("@/assets/img/masBlanco.svg"),
        description: "Añade o Edita un nuevo negocio a la lista",
        to: {
          name: "modelo_franquicia_catalogos_negocios"
        },
        color: "#494949"
      },
      breadcrumbs: [
        {
          text: "Plataforma de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "home"
          }
        },
        {
          text: "Modelo de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "modelo_franquicia"
          }
        },
        {
          text: "Franquicias",
          disabled: false,
          exact: true,
          to: {
            name: "modelo_franquicia_franquicias"
          }
        }
      ],
      franquiciaBackup: {
        id_franquicia: null,
        descripcion: "",
        id_status: null,
        fecha_creacion: null,
        id_empleado_crea: null,
        fecha_modificacion: null,
        id_empleado_modifica: null,
        negocios_franquicia: []
      },
      franquicia: {
        id_franquicia: null,
        descripcion: "",
        id_status: null,
        fecha_creacion: null,
        id_empleado_crea: null,
        fecha_modificacion: null,
        id_empleado_modifica: null,
        negocios_franquicia: []
      },
      negociosBackup: [],
      negocios: [],
      metadata: {},
      textoGestionFranquicia: null,
      access_token: serviceLocalStorage.getAccessToken()
    };
  },
  computed: {
    serviceCommons() {
      return serviceCommons;
    },
    hasGlobalChanges() {
      if (this.franquiciaBackup) {
        const originalValue = JSON.stringify(this.franquiciaBackup).replace(
          /"/g,
          ""
        );
        const currentValue = JSON.stringify(this.franquicia).replace(/"/g, "");
        return originalValue !== currentValue;
      } else {
        return this.franquicia.id_franquicia === undefined;
      }
    },
    franquiciaVuelidate() {
      let franquiciaVuelidate = JSON.parse(JSON.stringify(this.franquicia));
      return franquiciaVuelidate;
    }
  },
  validations: {
    franquiciaVuelidate: {
      descripcion: {
        required
      },
      negocios_franquicia: {
        required,
        $each: {
          ids_categorias: {
            required
          }
        }
      }
    }
  },
  methods: {
    async guardarCambios() {
      this.$v.$touch();
      if (!this.$v.$invalid) {
        var self = this;
        const isFranquicia = await this.existFranquicia();
        this.franquicia.id_empleado_modifica = user.empleado;
        this.franquicia.id_empleado_crea = user.empleado;
        this.savingFranquicia = true;
        if (!isFranquicia) {
          if (this.franquicia.id_franquicia) {
            axios
              .put("/franquicia/secure/put", this.franquicia)
              .then(response => {
                if (response) {
                  const data = response.data;
                  if (data.status_code === 200) {
                    self.dialogSave = true;
                    self.franquiciaBackup = JSON.parse(
                      JSON.stringify(self.franquicia)
                    );
                  } else {
                    console.log("No Update");
                  }
                }
              })
              .catch(error => {
                console.log(error);
              })
              .finally(function() {
                self.savingFranquicia = false;
              });
          } else {
            axios
              .post("/franquicia/secure/post", this.franquicia)
              .then(response => {
                if (response) {
                  const data = response.data;
                  if (data.status_code === 200) {
                    self.dialogSave = true;
                    self.franquiciaBackup = JSON.parse(
                      JSON.stringify(self.franquicia)
                    );
                  } else {
                    console.log("No Insert");
                  }
                }
              })
              .catch(error => {
                console.log(error);
              })
              .finally(function() {
                self.savingFranquicia = false;
              });
          }
        } else {
          self.savingFranquicia = false;
        }
      } else {
        this.dialogErrorValidation = true;
      }
    },
    async existFranquicia() {
      if (this.franquiciaBackup.descripcion === this.franquicia.descripcion) {
        return await false;
      } else {
        const self = this;
        return await axios
          .get(
            "/franquicia/secure/get/nombre?value=" + this.franquicia.descripcion
          )
          .then(response => {
            if (response) {
              if (response.data.status_code === 200) {
                const exist =
                  (response.data.track_code &&
                    response.data.track_code === 3006) === undefined;
                if (exist) {
                  self.dialogErrorValidationNombreFranquicia = true;
                  self.isUniqueFranquicia = false;
                }
                return exist;
              } else {
                return false;
              }
            }
          })
          .catch(error => {
            console.log(error);
            return false;
          })
          .finally(function() {});
      }
    },
    cancelGlobalChanges() {
      this.franquicia = JSON.parse(JSON.stringify(this.franquiciaBackup));
      this.negocios = JSON.parse(JSON.stringify(this.negociosBackup));
      this.dialogCancel = false;
      this.$v.$reset();
    },
    getNegocioFranquiciaById(idNegocio) {
      let negocio;
      this.franquicia.negocios_franquicia.forEach(
        (itemNegocioFranquicia, indexNegocioFranquicia) => {
          if (idNegocio == itemNegocioFranquicia.id_negocio) {
            negocio = itemNegocioFranquicia;
          }
        }
      );
      return negocio;
    },
    getIndexNegocioFranquiciaById(idNegocio) {
      let indexNegocioFranquiciaOut;
      this.franquicia.negocios_franquicia.forEach(
        (itemNegocioFranquicia, indexNegocioFranquicia) => {
          if (idNegocio == itemNegocioFranquicia.id_negocio) {
            indexNegocioFranquiciaOut = indexNegocioFranquicia;
          }
        }
      );
      return indexNegocioFranquiciaOut;
    },
    switchCheckNegocioFranquicia() {
      let negociosFranquicia = [];
      this.negocios.forEach(itemNegocio => {
        if (!itemNegocio.is_checked) {
          this.franquicia.negocios_franquicia = this.franquicia.negocios_franquicia.filter(
            itemNegocioFranquicia =>
              itemNegocioFranquicia.id_negocio !== itemNegocio.id_negocio
          );
        } else {
          negociosFranquicia.push(itemNegocio);
        }
      });
      this.franquicia.negocios_franquicia = negociosFranquicia;
    },
    initValues() {
      if (!this.franquicia.id_franquicia) {
        this.textoGestionFranquicia = "Crear una Franquicia";
        this.breadcrumbs.push({
          text: "Nueva",
          disabled: true
        });
      } else {
        this.breadcrumbs.push({
          text: "Edición",
          disabled: true
        });
        this.textoGestionFranquicia = "Editar una Franquicia";
      }
    },
    getFranquicia() {
      var self = this;
      axios
        .get("/franquicia/secure/get/data/" + self.franquicia.id_franquicia)
        .then(response => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              if (data.franquicia) {
                self.setFranquicia(data.franquicia);
              }
              if (data.metadata) {
                self.setNegocios(data.metadata.negocios);
              }
            }
          }
        })
        .catch(error => {
          console.log(error);
        })
        .finally(function() {});
    },
    getDataFranquicia() {
      var self = this;
      axios
        .get("/franquicia/secure/get/data/")
        .then(response => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              if (data.metadata) {
                self.setNegocios(data.metadata.negocios);
              }
            }
          }
        })
        .catch(error => {
          console.log(error);
        })
        .finally(function() {});
    },
    setNegocios(data) {
      if (data) {
        data.forEach(itemNegocio => {
          let idsCategorias = [];
          let negocioFranquicia = this.getNegocioFranquiciaById(
            itemNegocio.id_negocio
          );
          itemNegocio.is_checked = negocioFranquicia !== undefined;
          if (itemNegocio.is_checked) {
            idsCategorias = negocioFranquicia.ids_categorias;
          }
          itemNegocio.ids_categorias = idsCategorias;
          itemNegocio.path_logo =
            urlServicesPlataformaFranquicia +
            "/file/secure/read/" +
            this.serviceCommons.stringToBase64(itemNegocio.path_logo) +
            "?access_token=" +
            this.access_token;
        });
        this.negocios = data;
        this.negociosBackup = JSON.parse(JSON.stringify(this.negocios));
      }
    },
    setFranquicia(data) {
      this.franquicia = data;
      this.franquiciaBackup = JSON.parse(JSON.stringify(this.franquicia));
    }
  },
  created() {
    if (this.$route.params.franquicia) {
      this.franquicia = this.serviceCommons.base64ToObject(
        this.$route.params.franquicia
      );
      this.getFranquicia();
    } else {
      this.getDataFranquicia();
    }
    this.initValues();
  },
  beforeRouteLeave: function(to, from, next) {
    this.$refs.LeavePage.beforeRouteLeave(
      to,
      from,
      next,
      this.hasGlobalChanges
    );
  }
};
</script>
